ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.19 by greg, Fri Jun 3 19:41:14 2011 UTC vs.
Revision 2.38 by greg, Sun Sep 2 15:33:16 2012 UTC

# Line 8 | Line 8
8   use strict;
9   use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14   my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 + my @savedARGV = @ARGV;
17   my $tensortree = 0;
18   my $ttlog2 = 4;
19 < my $nsamp = 1000;
19 > my $nsamp = 2000;
20   my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 + my $pctcull = 90;
27 + my $gunit = "Meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
# Line 32 | Line 35 | while ($#ARGV >= 0) {
35                  shift @ARGV;
36          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37                  $geout = ("$ARGV[0]" =~ /^\+/);
38 +                $gunit = $ARGV[1];
39 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 +                }
42 +                shift @ARGV;
43          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44                  $doforw = ("$ARGV[0]" =~ /^\+/);
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52                  $tensortree = substr($ARGV[0], 2, 1);
53                  $ttlog2 = $ARGV[1];
# Line 59 | Line 71 | while ($#ARGV >= 0) {
71   }
72   # Check that we're actually being asked to do something
73   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
62 # Name our own persist file?
63 my $persistfile;
64 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
65        $persistfile = "$td/pfile.txt";
66        $rtargs = "-PP $persistfile $rtargs";
67 }
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 98 | Line 104 | die "Could not compile scene\n" if ( $? );
104   print
105   '<?xml version="1.0" encoding="UTF-8"?>
106   <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 < <WindowElementType>System</WindowElementType>
107 > ';
108 > print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 > print
110 > '<WindowElementType>System</WindowElementType>
111   <Optical>
112   <Layer>
113          <Material>
114                  <Name>Name</Name>
115                  <Manufacturer>Manufacturer</Manufacturer>
116   ';
117 < printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 < printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
119 < printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
117 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
119 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
120   print "\t\t<DeviceType>Integral</DeviceType>\n";
121   # Output MGF description if requested
122   if ( $geout ) {
123 <        print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
123 >        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
124          printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
125          open(MGFSCN, "< $mgfscn");
126          while (<MGFSCN>) { print $_; }
# Line 139 | Line 148 | print
148   </WindowElement>
149   ';
150   # Clean up temporary files and exit
142 if ( $persistfile && open(PFI, "< $persistfile") ) {
143        while (<PFI>) {
144                s/^[^ ]* //;
145                kill('ALRM', $_);
146                last;
147        }
148        close PFI;
149 }
151   exec("rm -rf $td");
152  
153   #-------------- End of main program segment --------------#
154  
155   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
156   sub do_tree_bsdf {
156 # Get sampling rate and subdivide task
157 my $ns2 = $ns;
158 $ns2 /= 2 if ( $tensortree == 3 );
159 @pdiv = (0, int($ns2/$nproc));
160 my $nrem = $ns2 % $nproc;
161 for (my $i = 1; $i < $nproc; $i++) {
162        my $nv = $pdiv[$i] + $pdiv[1];
163        ++$nv if ( $nrem-- > 0 );
164        push @pdiv, $nv;
165 }
166 die "Script error 1" if ($pdiv[-1] != $ns2);
157   # Shirley-Chiu mapping from unit square to disk
158   $sq2disk = '
159   in_square_a = 2*in_square_x - 1;
# Line 206 | Line 196 | out_square_y = (out_square_b + 1)/2;
196   print "\t<DataDefinition>\n";
197   print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198   print "\t</DataDefinition>\n";
199 < # Fork parallel rtcontrib processes to compute each side
200 < if ( $doback ) {
201 <        for (my $proc = 0; $proc < $nproc; $proc++) {
202 <                bg_tree_rtcontrib(0, $proc);
203 <        }
214 <        while (wait() >= 0) {
215 <                die "rtcontrib process reported error" if ( $? );
216 <        }
217 <        ttree_out(0);
218 < }
219 < if ( $doforw ) {
220 <        for (my $proc = 0; $proc < $nproc; $proc++) {
221 <                bg_tree_rtcontrib(1, $proc);
222 <        }
223 <        while (wait() >= 0) {
224 <                die "rtcontrib process reported error" if ( $? );
225 <        }
226 <        ttree_out(1);
227 < }
199 >
200 > # Start rcontrib processes for compute each side
201 > do_tree_rtcontrib(0) if ( $doback );
202 > do_tree_rtcontrib(1) if ( $doforw );
203 >
204   }       # end of sub do_tree_bsdf()
205  
206 < # Run i'th rtcontrib process for generating tensor tree samples
207 < sub bg_tree_rtcontrib {
232 <        my $pid = fork();
233 <        die "Cannot fork new process" unless defined $pid;
234 <        if ($pid > 0) { return $pid; }
206 > # Run rcontrib process to generate tensor tree samples
207 > sub do_tree_rtcontrib {
208          my $forw = shift;
236        my $pn = shift;
237        my $pbeg = $pdiv[$pn];
238        my $plen = $pdiv[$pn+1] - $pbeg;
209          my $matargs = "-m $bmodnm";
210 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
211 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
210 >        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
211 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212                  "-e '$disk2sq' -bn '$ns*$ns' " .
213                  "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
214 >                "-o $td/%s.flt $matargs $octree";
215          if ( $tensortree == 3 ) {
216                  # Isotropic BSDF
217 <                $cmd = "cnt $plen $ny $nx " .
218 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
219 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
220 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
221 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
217 >                my $ns2 = $ns / 2;
218 >                $cmd = "cnt $ns2 $ny $nx " .
219 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
220 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
221 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
222 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
223                          "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
224                          "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
225                          "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
# Line 259 | Line 230 | sub bg_tree_rtcontrib {
230                  # Anisotropic BSDF
231                  # Sample area vertically to improve load balance, since
232                  # shading systems usually have bilateral symmetry (L-R)
233 <                $cmd = "cnt $plen $ns $ny $nx " .
234 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
235 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
236 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
237 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
238 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
233 >                $cmd = "cnt $ns $ns $ny $nx " .
234 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
235 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
236 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
239                          "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240                          "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241                          "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
# Line 274 | Line 245 | sub bg_tree_rtcontrib {
245                          "| $cmd";
246          }
247   # print STDERR "Starting: $cmd\n";
248 <        exec($cmd);             # no return; status report to parent via wait
249 <        die "Cannot exec: $cmd\n";
250 < }       # end of bg_tree_rtcontrib()
248 >        system "$cmd" || die "Failure running rcontrib";
249 >        ttree_out($forw);
250 > }       # end of do_tree_rtcontrib()
251  
252   # Simplify and output tensor tree results
253   sub ttree_out {
254          my $forw = shift;
255          my $side = ("Back","Front")[$forw];
256 < # Only output one transmitted distribution, preferring backwards
257 < if ( !$forw || !$doback ) {
256 >        my $cmd;
257 > # Only output one transmitted anisotropic distribution, preferring backwards
258 > if ( !$forw || !$doback || $tensortree==3 ) {
259   print
260   '       <WavelengthData>
261                  <LayerNumber>System</LayerNumber>
# Line 291 | Line 263 | print
263                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
264                  <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
265                  <WavelengthDataBlock>
266 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
267 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
266 > ';
267 > print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
268 > print
269 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
270                          <ScatteringDataType>BTDF</ScatteringDataType>
271                          <ScatteringData>
272   ';
273 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
274 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
275 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
276 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
277 < die "Failure running rttree_reduce" if ( $? );
273 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
274 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
275 > if ($pctcull >= 0) {
276 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
277 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
278 >        system "$cmd" || die "Failure running rttree_reduce";
279 > } else {
280 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
281 >        print "{\n";
282 >        system "$cmd" || die "Failure running rcalc";
283 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
284 >                print "0\n";
285 >        }
286 >        print "}\n";
287 > }
288   print
289   '                       </ScatteringData>
290                  </WavelengthDataBlock>
# Line 317 | Line 301 | print
301                  <WavelengthDataBlock>
302   ';
303   print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
304 < print '                 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
304 > print
305 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
306                          <ScatteringDataType>BRDF</ScatteringDataType>
307                          <ScatteringData>
308   ';
309 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
310 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
311 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
312 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
313 < die "Failure running rttree_reduce" if ( $? );
309 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
310 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
311 > if ($pctcull >= 0) {
312 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
313 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
314 >        system "$cmd" || die "Failure running rttree_reduce";
315 > } else {
316 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
317 >        print "{\n";
318 >        system "$cmd" || die "Failure running rcalc";
319 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
320 >                print "0\n";
321 >        }
322 >        print "}\n";
323 > }
324   print
325   '                       </ScatteringData>
326                  </WavelengthDataBlock>
# Line 342 | Line 337 | sub do_matrix_bsdf {
337   $tcal = '
338   DEGREE : PI/180;
339   sq(x) : x*x;
340 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
340 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
341   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
342   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
343   Kmax : Kaccum(Knaz(0));
# Line 363 | Line 358 | KprojOmega = PI * if(Kbin-.5,
358   $kcal = '
359   DEGREE : PI/180;
360   abs(x) : if(x, x, -x);
361 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
361 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
362   posangle(a) : if(-a, a + 2*PI, a);
363 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
363 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
364   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
365   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
366   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 386 | Line 381 | kbin2(pol,azi) = select(kfindrow(1, pol),
381   kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
382   ';
383   my $ndiv = 145;
384 < # Compute scattering data using rtcontrib
384 > # Compute scattering data using rcontrib
385   my @tfarr;
386   my @rfarr;
387   my @tbarr;
388   my @rbarr;
389   my $cmd;
390 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
390 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
391          "-e '$kcal' -b kbin -bn $ndiv " .
392          "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
393   my $rccmd = "rcalc -e '$tcal' " .
394          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
395 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
395 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
396   if ( $doforw ) {
397   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
398          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 423 | Line 418 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
418   system "$cmd" || die "Failure running: $cmd\n";
419   @tbarr = `$rccmd $td/$bmodnm.flt`;
420   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
421 + chomp(@tbarr);
422   @rbarr = `$rccmd $td/$fmodnm.flt`;
423   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
424 + chomp(@rbarr);
425   }
426   # Output angle basis
427   print
# Line 433 | Line 430 | print
430                  <AngleBasis>
431                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
432                          <AngleBasisBlock>
433 <                                <Theta>0</Theta>
434 <                                <nPhis>1</nPhis>
435 <                                <ThetaBounds>
436 <                                        <LowerTheta>0</LowerTheta>
437 <                                        <UpperTheta>5</UpperTheta>
438 <                                </ThetaBounds>
442 <                                </AngleBasisBlock>
443 <                                <AngleBasisBlock>
444 <                                <Theta>10</Theta>
445 <                                <nPhis>8</nPhis>
446 <                                <ThetaBounds>
447 <                                        <LowerTheta>5</LowerTheta>
448 <                                        <UpperTheta>15</UpperTheta>
449 <                                </ThetaBounds>
450 <                                </AngleBasisBlock>
451 <                                <AngleBasisBlock>
452 <                                <Theta>20</Theta>
453 <                                <nPhis>16</nPhis>
454 <                                <ThetaBounds>
455 <                                        <LowerTheta>15</LowerTheta>
456 <                                        <UpperTheta>25</UpperTheta>
457 <                                </ThetaBounds>
458 <                                </AngleBasisBlock>
459 <                                <AngleBasisBlock>
460 <                                <Theta>30</Theta>
461 <                                <nPhis>20</nPhis>
462 <                                <ThetaBounds>
463 <                                        <LowerTheta>25</LowerTheta>
464 <                                        <UpperTheta>35</UpperTheta>
465 <                                </ThetaBounds>
466 <                                </AngleBasisBlock>
467 <                                <AngleBasisBlock>
468 <                                <Theta>40</Theta>
469 <                                <nPhis>24</nPhis>
470 <                                <ThetaBounds>
471 <                                        <LowerTheta>35</LowerTheta>
472 <                                        <UpperTheta>45</UpperTheta>
473 <                                </ThetaBounds>
474 <                                </AngleBasisBlock>
475 <                                <AngleBasisBlock>
476 <                                <Theta>50</Theta>
477 <                                <nPhis>24</nPhis>
478 <                                <ThetaBounds>
479 <                                        <LowerTheta>45</LowerTheta>
480 <                                        <UpperTheta>55</UpperTheta>
481 <                                </ThetaBounds>
482 <                                </AngleBasisBlock>
483 <                                <AngleBasisBlock>
484 <                                <Theta>60</Theta>
485 <                                <nPhis>24</nPhis>
486 <                                <ThetaBounds>
487 <                                        <LowerTheta>55</LowerTheta>
488 <                                        <UpperTheta>65</UpperTheta>
489 <                                </ThetaBounds>
490 <                                </AngleBasisBlock>
491 <                                <AngleBasisBlock>
492 <                                <Theta>70</Theta>
493 <                                <nPhis>16</nPhis>
494 <                                <ThetaBounds>
495 <                                        <LowerTheta>65</LowerTheta>
496 <                                        <UpperTheta>75</UpperTheta>
497 <                                </ThetaBounds>
498 <                                </AngleBasisBlock>
499 <                                <AngleBasisBlock>
500 <                                <Theta>82.5</Theta>
501 <                                <nPhis>12</nPhis>
502 <                                <ThetaBounds>
503 <                                        <LowerTheta>75</LowerTheta>
504 <                                        <UpperTheta>90</UpperTheta>
505 <                                </ThetaBounds>
433 >                        <Theta>0</Theta>
434 >                        <nPhis>1</nPhis>
435 >                        <ThetaBounds>
436 >                                <LowerTheta>0</LowerTheta>
437 >                                <UpperTheta>5</UpperTheta>
438 >                        </ThetaBounds>
439                          </AngleBasisBlock>
440 +                        <AngleBasisBlock>
441 +                        <Theta>10</Theta>
442 +                        <nPhis>8</nPhis>
443 +                        <ThetaBounds>
444 +                                <LowerTheta>5</LowerTheta>
445 +                                <UpperTheta>15</UpperTheta>
446 +                        </ThetaBounds>
447 +                        </AngleBasisBlock>
448 +                        <AngleBasisBlock>
449 +                        <Theta>20</Theta>
450 +                        <nPhis>16</nPhis>
451 +                        <ThetaBounds>
452 +                                <LowerTheta>15</LowerTheta>
453 +                                <UpperTheta>25</UpperTheta>
454 +                        </ThetaBounds>
455 +                        </AngleBasisBlock>
456 +                        <AngleBasisBlock>
457 +                        <Theta>30</Theta>
458 +                        <nPhis>20</nPhis>
459 +                        <ThetaBounds>
460 +                                <LowerTheta>25</LowerTheta>
461 +                                <UpperTheta>35</UpperTheta>
462 +                        </ThetaBounds>
463 +                        </AngleBasisBlock>
464 +                        <AngleBasisBlock>
465 +                        <Theta>40</Theta>
466 +                        <nPhis>24</nPhis>
467 +                        <ThetaBounds>
468 +                                <LowerTheta>35</LowerTheta>
469 +                                <UpperTheta>45</UpperTheta>
470 +                        </ThetaBounds>
471 +                        </AngleBasisBlock>
472 +                        <AngleBasisBlock>
473 +                        <Theta>50</Theta>
474 +                        <nPhis>24</nPhis>
475 +                        <ThetaBounds>
476 +                                <LowerTheta>45</LowerTheta>
477 +                                <UpperTheta>55</UpperTheta>
478 +                        </ThetaBounds>
479 +                        </AngleBasisBlock>
480 +                        <AngleBasisBlock>
481 +                        <Theta>60</Theta>
482 +                        <nPhis>24</nPhis>
483 +                        <ThetaBounds>
484 +                                <LowerTheta>55</LowerTheta>
485 +                                <UpperTheta>65</UpperTheta>
486 +                        </ThetaBounds>
487 +                        </AngleBasisBlock>
488 +                        <AngleBasisBlock>
489 +                        <Theta>70</Theta>
490 +                        <nPhis>16</nPhis>
491 +                        <ThetaBounds>
492 +                                <LowerTheta>65</LowerTheta>
493 +                                <UpperTheta>75</UpperTheta>
494 +                        </ThetaBounds>
495 +                        </AngleBasisBlock>
496 +                        <AngleBasisBlock>
497 +                        <Theta>82.5</Theta>
498 +                        <nPhis>12</nPhis>
499 +                        <ThetaBounds>
500 +                                <LowerTheta>75</LowerTheta>
501 +                                <UpperTheta>90</UpperTheta>
502 +                        </ThetaBounds>
503 +                        </AngleBasisBlock>
504                  </AngleBasis>
505          </DataDefinition>
506   ';
# Line 524 | Line 521 | print
521   # Output front transmission (transposed order)
522   for (my $od = 0; $od < $ndiv; $od++) {
523          for (my $id = 0; $id < $ndiv; $id++) {
524 <                print $tfarr[$ndiv*$id + $od];
524 >                print $tfarr[$ndiv*$id + $od], ",\n";
525          }
526          print "\n";
527   }
# Line 547 | Line 544 | print
544   # Output front reflection (transposed order)
545   for (my $od = 0; $od < $ndiv; $od++) {
546          for (my $id = 0; $id < $ndiv; $id++) {
547 <                print $rfarr[$ndiv*$id + $od];
547 >                print $rfarr[$ndiv*$id + $od], ",\n";
548          }
549          print "\n";
550   }
# Line 574 | Line 571 | print
571   # Output back transmission (transposed order)
572   for (my $od = 0; $od < $ndiv; $od++) {
573          for (my $id = 0; $id < $ndiv; $id++) {
574 <                print $tbarr[$ndiv*$id + $od];
574 >                print $tbarr[$ndiv*$id + $od], ",\n";
575          }
576          print "\n";
577   }
# Line 597 | Line 594 | print
594   # Output back reflection (transposed order)
595   for (my $od = 0; $od < $ndiv; $od++) {
596          for (my $id = 0; $id < $ndiv; $id++) {
597 <                print $rbarr[$ndiv*$id + $od];
597 >                print $rbarr[$ndiv*$id + $od], ",\n";
598          }
599          print "\n";
600   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines